package dammfine.jife;

import f00f.net.irc.martyr.Debug;

import java.sql.Driver;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.SQLException;
import java.sql.Date;

import java.util.Properties;
import java.util.List;

public class DatabaseCheckLogger implements CheckLogger
{
	private Connection dbConnection;
	private String name;

	public void init( String name, Properties p )
		throws BadConfigException
	{
		this.name = name;

		dbConnection = DBUtils.getDBConnection( this, p );
	}
	
	public void logCheck( String word, String nick, String sentTo, List results )
		throws JifeException
	{
		try
		{
			Statement stmt = dbConnection.createStatement();
			String query = "insert into check_requests "
				+ "(word, nick, sentto, datestamp, results) "
				+ "values ('"
				+ DBUtils.escapeSQL( word ) + "', '"
				+ DBUtils.escapeSQL( nick ) + "', '"
				+ DBUtils.escapeSQL( sentTo ) + "', '"
				+ new Date(System.currentTimeMillis()) + "', '"
				+ DBUtils.escapeSQL( results.toString() ) + "')";
			Debug.println( this, "Executing: " + query, Debug.EXCESSIVE );
			stmt.executeUpdate( query );
		}
		catch( SQLException sqle )
		{
			Debug.println( this, "Error writing log for " + word + " from " + nick, Debug.CRITICAL );
			System.err.println( sqle );
		//	throw new JifeException( "Sorry, we appear to be having database problems." );
		}
	}

	public String toString()
	{
		return "DatabaseCheckLogger[" + name + "]";
	}
}

