package dammfine.jife;
/*
 * THIS FILE IS OBSOLETE!!!!
 * It is hanging around just 'cause.
 */
import java.util.HashMap;
import java.util.Iterator;
import java.util.Collections;
import java.util.Set;
import java.util.HashSet;
import java.util.StringTokenizer;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.IOException;

import dammfine.util.Metaphone;

public class LookupTree
{
	private HashMap children;
	private HashSet values;
	
	public LookupTree()
	{
		children = new HashMap();
		values = new HashSet();
	}
	
	public static LookupTree loadLookupTree( BufferedReader reader )
		throws IOException
	{
		LookupTree root = new LookupTree();
		String line;
		while( (line=reader.readLine())!= null )
		{
			StringTokenizer tokens = new StringTokenizer(line, " \t,");
			
			String key = tokens.nextToken();
			String value = tokens.nextToken();

			root.addMatch( key, value );
		}

		return root;
	}
	
	public void addMatch( String key, String value )
	{
		if( key.equals( "" ) )
		{
			values.add( value );
			return;
		}
		Character keyChar = new Character( key.charAt(0) );

		LookupTree subTree = (LookupTree)children.get(keyChar);

		if( subTree == null )
		{
			subTree = new LookupTree();
			children.put( keyChar, subTree );
		}

		subTree.addMatch( key.substring(1), value );
	}
	
	/**
	 * Returns a read only hash set of strings.
	 */
	public Set getMatches( String chars )
	{
		if( chars.equals("") )
		{
			return Collections.unmodifiableSet( values );
		}
		char keyChar = chars.charAt(0);
		
		LookupTree subTree = (LookupTree)children.get( new Character(keyChar) );
		
		if( subTree == null )
		{
			return new HashSet();
		}
		else
		{
			return subTree.getMatches( chars.substring(1) );
		}
	}
	
	/**
	 * Runs LookupTree.loadLookupTree on the first argument, and then
	 * reads in one word a line from stdin, writing the encoded
	 * version and words that match it on stdout.
	 *
	 * */
	public static void main( String args[] )
		throws IOException
	{
		FileReader reader = new FileReader( args[0] );
		
		LookupTree tree = LookupTree.loadLookupTree( new BufferedReader( reader ) );

		BufferedReader inReader = new BufferedReader( new InputStreamReader( System.in ) );

		String checkWord;

		while( (checkWord=inReader.readLine()) != null )
		{
			String codedString = Metaphone.metaPhone( checkWord );
			System.out.println( "Encoded to " + codedString );
			
			Set results = tree.getMatches( codedString );
			System.out.println( results );
		}
	}
}

