package dammfine.tools;

import dammfine.util.Metaphone;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

/**
 * For every line on standard in (it is assumed one line == one word)
 * the main method computes a metaphone and outputs the word, a space,
 * and the metaphone on standard out.
 *
 * */
public class MetaphoneEncoder
{
	public static void main( String args[] )
		throws IOException
	{
		BufferedReader in = 
			new BufferedReader( new InputStreamReader( System.in) );

		String line;

		// while we have lines of input
		while( ( line = in.readLine() ) != null )
		{
			String mphone = Metaphone.metaPhone( line );
			System.out.println( line + " " + mphone );
		}
	}
}
