package dammfine.dict.receiving;

import java.io.IOException;
import java.io.BufferedReader;
import java.util.Map;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.List;
import java.util.LinkedList;
import dammfine.dict.ReceivingCommand;

public class DefinitionCommand extends GenericReceivingTextCommand
{
	private static final Integer statNum = new Integer( 151 );
	private List definitions = null;
	
	/**
	 * This is used to make a factory.
	 */
	private DefinitionCommand()
	{
	}
	
	private DefinitionCommand( List dsfs )
	{
		this.definitions = dsfs;
	}

	public static DefinitionCommand getFactory()
	{
		return new DefinitionCommand();
	}
	
	public List getDefinitions()
	{
		return definitions;
	}
	public Integer getStatusCode()
	{
		return statNum;
	}

	public ReceivingCommand parse( String lineOne, BufferedReader reader )
		throws IOException
	{
		List lines = new LinkedList();
		lines.add( lineOne );
		readCommandText( reader, lines );

		return new DefinitionCommand( lines );
	}
}
