package dammfine.dict.receiving;

import java.io.BufferedReader;
import java.io.IOException;

import dammfine.dict.ReceivingCommand;

/**
 * The 220 command sent on connection.
 */
public class ServerInfoCommand extends GenericReceivingCommand
{
	private static final Integer statCode = new Integer( 220 );
	
	public Integer getStatusCode()
	{
		return statCode;
	}
	
	public ReceivingCommand parse( String firstLine, BufferedReader reader )	
		throws IOException
	{
		// No info yet.
		return new ServerInfoCommand();
	}
}

