package dammfine.jife;

import java.util.Set;
import f00f.net.irc.martyr.util.FullNick;

public interface JifeCommand
{
	void processCommand( String cmd, FullNick sender, String replyTo, String input, boolean toGroup ) throws JifeException;
	void sendHelp( String replyTo, String input );
	/**
	 * Returns a set of strings that represents the commands this
	 * command would like to respond to.
	 */
	Set getCommandSet();
	/**
	 * @return a short summary of what this command does.
	 */
	String getSummary();
}
