package dammfine.jife;

import java.util.Set;
import java.util.Iterator;
import java.util.Properties;
import java.util.Collections;
import java.util.StringTokenizer;

import f00f.net.irc.martyr.util.FullNick;

public class ListDbCommand implements JifeCommand
{
	private Jife jife = null;

	public ListDbCommand( Jife jife )
	{
		this.jife = jife;
	}
	 
	public void processCommand( String cmd, FullNick sender, String replyTo, String input, boolean toGroup )
		throws JifeException
	{
		DefinitionSource ds = jife.getDefinitionSource();
	}

	public void sendHelp( String replyTo, String input )
	{
	}

	/**
	 * Returns a set of strings that represents the commands this
	 * command would like to respond to.
	 */
	public Set getCommandSet()
	{
		return Collections.singleton( "lsd" );
	}
	/**
	 * @return a short summary of what this command does.
	 */
	public String getSummary()
	{
		return "Lists the various dictionaries available to the define command.";
	}
}
